<?php

dl('php_mapscript.so');

if (isset($HTTP_POST_VARS["tail_length"]))
 {
 $val_tail_length = $HTTP_POST_VARS["tail_length"];
 }
else
 {
 $val_tail_length=2;	
 }

$val_zsize=3;
$check_pan="CHECKED";
 
$map_path="/opt/nccoos_map/maps/";
$map_file="drifter.map";

$map = ms_newMapObj($map_path.$map_file);

// set time 
$time = date('Y_m_d_H_\00_\00', (time() - (3 * 60 * 60)));

// set temporal bracket values
$offset = $val_tail_length * 24;
$offset_tail = $offset - 24;

// set Trajectory Filter bracket
$layerObj = $map->getLayerByName('particle_trajectory');
$layerObj->setFilter("(sensor_id IN (select row_id from sensor where type_id ='1')) AND (m_date > (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS') - interval '".$offset." hours')) AND (m_date < (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS')))");
		
// set Tail Filter bracket
$layerObj1 = $map->getLayerByName('particle_tail');
$layerObj1->setFilter("(sensor_id IN (SELECT row_id FROM sensor WHERE type_id ='1')) AND (row_id IN (select min(row_id) FROM multi_obs WHERE (m_date >(to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS') - interval '".$offset." hours')) AND (m_date < (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS') - interval '".$offset_tail." hours')) GROUP BY platform_handle ))");

// set Head Filter time
$layerObj2 = $map->getLayerByName('particle_head');
$layerObj2->setFilter("(sensor_id IN (select row_id from sensor where type_id ='1')) AND (row_id IN (select max(row_id) FROM multi_obs WHERE (m_date > (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS') - interval '10 hours')) AND (m_date < (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS'))) GROUP BY platform_handle ))" );

// set Head Label Filter time
$layerObj3 = $map->getLayerByName('particle_head_label');
$layerObj3->setFilter("(sensor_id IN (select row_id from sensor where type_id ='1'))  AND (row_id IN (select max(row_id) FROM multi_obs WHERE (m_date > (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS') - interval '10 hours' )) and  (m_date < (to_timestamp('".$time."','YYYY_MM_DD_HH_MI_SS'))) GROUP BY platform_handle ))");

if (!isset($HTTP_POST_VARS["full"]) && (isset($HTTP_POST_VARS["extent"]))) 
        { 
        $extent_to_set = explode(" ",$HTTP_POST_VARS["extent"]); 
        $map->setextent($extent_to_set[0],$extent_to_set[1],
                      $extent_to_set[2],$extent_to_set[3]);
	}
	
if (!isset($HTTP_POST_VARS["full"]) && (isset($HTTP_POST_VARS["seacoos"]))) 
        { 
        // -88.5 22.5 -69.19 37.9
        $map->setextent(-88.5,22.5,-69.19,37.9);
	}

if ( isset($HTTP_POST_VARS["map_x"]) && isset($HTTP_POST_VARS["map_y"])
      && !isset($HTTP_POST_VARS["full"]) ) {

      $extent_to_set = explode(" ",$HTTP_POST_VARS["extent"]); 
      $map->setextent($extent_to_set[0],$extent_to_set[1],
                      $extent_to_set[2],$extent_to_set[3]);

      $my_point = ms_newpointObj();
      $my_point->setXY($HTTP_POST_VARS["map_x"],$HTTP_POST_VARS["map_y"]);

      $my_extent = ms_newrectObj();
     $my_extent->setextent($extent_to_set[0],$extent_to_set[1],
                              $extent_to_set[2],$extent_to_set[3]);

      $zoom_factor = $HTTP_POST_VARS["zoom"]*$HTTP_POST_VARS["zsize"];
      if ($zoom_factor == 0) {
              $zoom_factor = 1;
              $check_pan = "CHECKED";
              $check_zout = "";
              $check_zin = "";
      } else if ($zoom_factor < 0) {
              $check_pan = "";
              $check_zout = "CHECKED";
              $check_zin = "";
      } else {
              $check_pan = "";
              $check_zout = "";
              $check_zin = "CHECKED";
      }

      $val_zsize = abs($zoom_factor);

      $map->zoompoint($zoom_factor,$my_point,$map->width,$map->height,
                      $my_extent);

 }

$map->selectOutputFormat(png);

$image=$map->draw();
$image_url=$image->saveWebImage();

$extent_to_html = $map->extent->minx." ".$map->extent->miny." "
           .$map->extent->maxx." ".$map->extent->maxy;

?>

<HTML>
<HEAD>
<TITLE>Drifter "Tail" Length Testing<TITLE>
</HEAD>
<BODY>
<FORM METHOD=POST ACTION=<?php echo $HTTP_SERVER_VARS['PHP_SELF']?>>
<TABLE>
	<TR>
		<TD colspan = 4>
			<b>Request Time: <?php echo $time?> (EST/EDT).</b>    
		</td>

	</tr>
	<tr><td colspan=4></tr>
	<tr>
		<td rowspan=8 colspan= 3>
			<INPUT TYPE=IMAGE NAME="map" SRC="<?php echo $image_url?>">
		</td>
	</tr>
	<TR>
		<TD>
			Re-Center <INPUT TYPE=RADIO NAME="zoom" VALUE=0 <?php echo $check_pan?>>
		</TD>
	</tr>
	<tr>
	        <TD>
			Zoom In <INPUT TYPE=RADIO NAME="zoom" VALUE=1 <?php echo $check_zin?>>
		</TD>
	</tr>
	<tr>
		<TD>
			Zoom Out <INPUT TYPE=RADIO NAME="zoom" VALUE=-1 <?php echo $check_zout?>>
		</TD>
	</TR>
	<tr>
		<TD>
			Zoom Factor <INPUT TYPE=TEXT NAME="zsize" VALUE="<?php echo $val_zsize?>" SIZE=2>
	      	</TD>
	</tr>
	<tr><td>&nbsp;</td></tr>
	<tr><td>&nbsp;</td></tr>
	<tr><td>&nbsp;</td></tr>
	<tr><td colspan=4></tr>
	<tr>
	  	<td>
			Tail Length (days) <INPUT TYPE=TEXT NAME="tail_length" VALUE="<?php echo $val_tail_length?>" SIZE=1> 
		</td>
			<td><INPUT TYPE=SUBMIT NAME="tail" VALUE="Redraw Tails" SIZE=2></td>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td></td>
	<tr><td colspan=4></tr>	
	<TR>
	        <TD>
			<INPUT TYPE=SUBMIT NAME="seacoos" VALUE="SEACOOS Extent" SIZE=2>
		</TD>
		<TD>
			<INPUT TYPE=SUBMIT NAME="full" VALUE="RS Map Extent"  SIZE=2>
		</TD>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td></td>
	</tr>
</table>
<INPUT TYPE=HIDDEN NAME="extent" VALUE="<?php echo $extent_to_html?>">
</form>
</body>
</html>

